<?php

// WebLogBook version7
// Copyright 2018 Hashimoto Mitsuhiro

mb_language("ja");
mb_internal_encoding("UTF-8");
header("Content-Type:text/html; charset=UTF-8");

if (isset($_GET["line"])) {$line = $_GET["line"];}
if (($_POST["date"] != "") and ($_POST["start"] != "") and ($_POST["callsign"] != "--") and ($_POST["rstur"] != "--") and ($_POST["rstmy"] != "--") and ($_POST["freq"] != "--") and ($_POST["mode"] != "")) {

if (isset($_POST["callsign"])) {
$callsign = $_POST["callsign"];
$callsign = mb_convert_kana($callsign, 'a');
if (!preg_match("/^[!-~]+$/",$callsign)) {$callsign = "?"; }
$callsign = strtoupper($callsign);
if (get_magic_quotes_gpc()) { $callsign = stripslashes("$callsign"); }
$callsign = htmlspecialchars($callsign);
$callsign = str_replace(",", "&#44;", $callsign);
}

if (isset($_POST["date"])) {
$date = $_POST["date"];
$date = mb_convert_kana($date, 'a');
if (get_magic_quotes_gpc()) { $date = stripslashes("$date"); }
$date = htmlspecialchars($date);
}

if (isset($_POST["start"])) {
$start = $_POST["start"];
$start = mb_convert_kana($start, 'a');
if (get_magic_quotes_gpc()) { $start = stripslashes("$start"); }
$start = htmlspecialchars($start);
}

if (isset($_POST["zone"])) {
$zone = $_POST["zone"];
$zone = mb_convert_kana($zone, 'a');
if (get_magic_quotes_gpc()) { $zone = stripslashes("$zone"); }
$zone = htmlspecialchars($zone);
}

if (isset($_POST["cq"])) {
$cq = $_POST["cq"];
$cq = mb_convert_kana($cq, 'a');
if (get_magic_quotes_gpc()) { $cq = stripslashes("$cq"); }
$cq = htmlspecialchars($cq);
}

if (isset($_POST["rstur"])) {
$rstur = $_POST["rstur"];
$rstur = mb_convert_kana($rstur, 'a');
if (!preg_match("/^[0-9\+\-]+$/",$rstur)) {$rstur="?"; }
if (get_magic_quotes_gpc()) { $rstur = stripslashes("$rstur"); }
$rstur = htmlspecialchars($rstur);
}

if (isset($_POST["rstmy"])) {
$rstmy = $_POST["rstmy"];
$rstmy = mb_convert_kana($rstmy, 'a');
if (!preg_match("/^[0-9\+\-]+$/",$rstmy)) {$rstmy="?"; }
if (get_magic_quotes_gpc()) { $rstmy = stripslashes("$rstmy"); }
$rstmy = htmlspecialchars($rstmy);
}

if (isset($_POST["freq"])) {
$freq = $_POST["freq"];
$freq = mb_convert_kana($freq, 'a');
if (get_magic_quotes_gpc()) { $freq = stripslashes("$freq"); }
$freq = htmlspecialchars($freq);
$freq = str_replace(",", "&#44;", $freq);
}

if (isset($_POST["mode"])) {
$mode = $_POST["mode"];
$mode = mb_convert_kana($mode, 'a');
if (get_magic_quotes_gpc()) { $mode = stripslashes("$mode"); }
$mode = htmlspecialchars($mode);
}

if (isset($_POST["op"])) {
$op = $_POST["op"];
$op = mb_convert_kana($op, 'a');
if (get_magic_quotes_gpc()) { $op = stripslashes("$op"); }
$op = htmlspecialchars($op);
$op = str_replace(",", "&#44;", $op);
}

if (isset($_POST["qth"])) {
$qth = $_POST["qth"];
$qth = mb_convert_kana($qth, 'a');
if (get_magic_quotes_gpc()) { $qth = stripslashes("$qth"); }
$qth = htmlspecialchars($qth);
$qth = str_replace(",", "&#44;", $qth);
}

if (isset($_POST["qsl"])) {
$qsl = $_POST["qsl"];
$qsl = mb_convert_kana($qsl, 'a');
if (get_magic_quotes_gpc()) { $qsl = stripslashes("$qsl"); }
$qsl = htmlspecialchars($qsl);
$qsl = str_replace(",", "&#44;", $qsl);
}

if (isset($_POST["rem"])) {
$rem = $_POST["rem"];
$rem = mb_convert_kana($rem, 'a');
if (get_magic_quotes_gpc()) { $rem = stripslashes("$rem"); }
$rem = htmlspecialchars($rem);
$rem = str_replace(",", "&#44;", $rem);
}

$data = fopen("./logdata.csv","r");

$bdata = fgets($data);

list($bcallsign,$bdate,$bstart,$bzone,$bcq,$brstur,$brstmy,$bfreq,$bmode,$bop,$bqth,$bqsl,$brem) = explode(",",$bdata);

fclose($data);

if (($bcallsign != $callsign) or ($bstart != $start)){
$time = date("Y/n/j G:i");
$ip = getenv("REMOTE_ADDR");
$host = gethostbyaddr(getenv("REMOTE_ADDR"));
$iphost = ($host . "/" . $ip);
$log = file("./logdata.csv");
$topwrite = "$callsign,$date,$start,$zone,$cq,$rstur,$rstmy,$freq,$mode,$op,$qth,$qsl,$rem,$time,$ip,$host\n";

$write = fopen("./logdata.csv","w");
flock($write, LOCK_EX);
fputs($write, $topwrite);
for($i = 0; $i < 999999; $i++){
fputs($write, $log[$i]);
}
flock ($write, LOCK_UN);
fclose ($write);
}
}
?>

<!DOCTYPE html>

<html lang="ja">

<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="shortcut icon" href="https://jg3rtl.info/logicon.ico" type="image/x-icon">
<meta name="author" content="JG3RTL(Hashimoto Mitsuhiro)">
<link rel="stylesheet" href="./logbook-mobile.css">
<!-- † -->
<title>WebLogBook mobile</title>
</head>

<body>

<h1>Log Book</h1>

<h2>input</h2>
<div class="in">
<form method="POST">
<table>
<tr><td>date</td><td><input type="date" name="date" tabindex="1"></td></tr>
<tr><td>start time</td><td><input class="time" type="time" name="start" tabindex="2"></td></tr>
<tr><td>time zone</td><td><select name="zone" tabindex="3"><option selected="selected" value="JST">JST</option><option value="UTC">UTC</option></select></td></tr>
<tr><td>callsign</td><td><input class="callsign" type="text" name="callsign" maxlength="15" tabindex="4" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>call/response</td><td><select name="cq" tabindex="5"><option selected="selected" value="call">call</option><option value="res">res</option></select></td></tr>
<tr><td>RST(his signal)</td><td><input class="rst" type="text" name="rstur" maxlength="3" tabindex="6" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>RST(my signal)</td><td><input class="rst" type="text" name="rstmy" maxlength="3" tabindex="7" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>band(MHz)</td><td><input class="freq" type="text" name="freq" maxlength="11" tabindex="8" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>mode</td><td><select name="mode" tabindex="9"><option selected="selected" value="FM">FM</option><option value="AM">AM</option><option value="SSB">SSB</option><option value="CW">CW</option><option value="Packet">Packet</option><option value="RTTY">RTTY</option><option value="PSK31">PSK31</option><option value="FAX">FAX</option><option value="SSTV">SSTV</option><option value="ATV">ATV</option><option value="EME">EME</option><option value="other">other</option></select></td></tr>
<tr><td>operator</td><td><input class="op" type="text" name="op" tabindex="10" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>QTH</td><td><input class="qth" type="text" name="qth" tabindex="11" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>QSL</td><td><input class="qsl" type="text" name="qsl" tabindex="12" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
<tr><td>remarks</td><td><input class="rem" type="text" name="rem" tabindex="13" onFocus="if (this.value == '--') this.value = '';" onBlur="if (this.value == '') this.value = '--';" value="--"></td></tr>
</table>
<p><input class="send" type="submit" value="send"></p>
</form>
</div>

<h2>record</h2>
<?php
$log = file("./logdata.csv");
if (!$line) {
$line = 0;
}
$pageline = 5;
for ($i = $line; $i < $line+$pageline; $i++) {
$list = explode(",",$log[$i]);
if(($list[0] != "") or ($list[1] != "")){
?>

<div class="in">
<table>
<tr><td>date</td><td><?php print $list[1]; ?></td></tr>
<tr><td>start time</td><td><?php print $list[2]; ?></td></tr>
<tr><td>time zone</td><td><?php print $list[3]; ?></td></tr>
<tr><td>callsign</td><td><?php print $list[0]; ?></td></tr>
<tr><td>call/response</td><td><?php print $list[4]; ?></td></tr>
<tr><td>RST(his signal)</td><td><?php print $list[5]; ?></td></tr>
<tr><td>RST(my signal)</td><td><?php print $list[6]; ?></td></tr>
<tr><td>band(MHz)</td><td><?php print $list[7]; ?></td></tr>
<tr><td>mode</td><td><?php print $list[8]; ?></td></tr>
<tr><td>operator</td><td><?php print $list[9]; ?></td></tr>
<tr><td>QTH</td><td><?php print $list[10]; ?></td></tr>
<tr><td>QSL</td><td><?php print $list[11]; ?></td></tr>
<tr><td>remarks</td><td><?php print $list[12]; ?></td></tr>
</table>
</div>

<?php
}
}
$totalline = (count($log));
$totalpage = ceil(($totalline / $pageline));
if ($totalline > $pageline) {
$back = $totalline;
$now = 1;
$next = 0;

print "<div class='page'>";
for ($i = $line; $back >= 1; $i++) {
if ($line == $next) {
print "<span class='now'>" . "$now" . "</span>&nbsp;";
}
else {
print "<a href='logbook-mobile.php?line=" . $next . "'><span class='pno'>" . $now . "</span></a> ";
}
$now++;
$next = $next + $pageline;
$back = $back - $pageline;
}
print "</div>";
}
?>

</body>
</html>