<?php

// WebLogBook version7
// Copyright 2018 Hashimoto Mitsuhiro

mb_language("ja");
mb_internal_encoding("UTF-8");
header("Content-Type:text/html; charset=UTF-8");

if (isset($_GET["line"])) {$line = $_GET["line"];}
if (($_POST["date"] != "") and ($_POST["start"] != "") and ($_POST["callsign"] != "--") and ($_POST["rstur"] != "--") and ($_POST["rstmy"] != "--") and ($_POST["freq"] != "--") and ($_POST["mode"] != "")) {

if (isset($_POST["callsign"])) {
$callsign = $_POST["callsign"];
$callsign = mb_convert_kana($callsign, 'a');
if (!preg_match("/^[!-~]+$/",$callsign)) {$callsign = "?"; }
$callsign = strtoupper($callsign);
if (get_magic_quotes_gpc()) { $callsign = stripslashes("$callsign"); }
$callsign = htmlspecialchars($callsign);
$callsign = str_replace(",", "&#44;", $callsign);
}

if (isset($_POST["date"])) {
$date = $_POST["date"];
$date = mb_convert_kana($date, 'a');
if (get_magic_quotes_gpc()) { $date = stripslashes("$date"); }
$date = htmlspecialchars($date);
}

if (isset($_POST["start"])) {
$start = $_POST["start"];
$start = mb_convert_kana($start, 'a');
if (get_magic_quotes_gpc()) { $start = stripslashes("$start"); }
$start = htmlspecialchars($start);
}

if (isset($_POST["zone"])) {
$zone = $_POST["zone"];
$zone = mb_convert_kana($zone, 'a');
if (get_magic_quotes_gpc()) { $zone = stripslashes("$zone"); }
$zone = htmlspecialchars($zone);
}

if (isset($_POST["cq"])) {
$cq = $_POST["cq"];
$cq = mb_convert_kana($cq, 'a');
if (get_magic_quotes_gpc()) { $cq = stripslashes("$cq"); }
$cq = htmlspecialchars($cq);
}

if (isset($_POST["rstur"])) {
$rstur = $_POST["rstur"];
$rstur = mb_convert_kana($rstur, 'a');
if (!preg_match("/^[0-9\+\-]+$/",$rstur)) {$rstur="?"; }
if (get_magic_quotes_gpc()) { $rstur = stripslashes("$rstur"); }
$rstur = htmlspecialchars($rstur);
}

if (isset($_POST["rstmy"])) {
$rstmy = $_POST["rstmy"];
$rstmy = mb_convert_kana($rstmy, 'a');
if (!preg_match("/^[0-9\+\-]+$/",$rstmy)) {$rstmy="?"; }
if (get_magic_quotes_gpc()) { $rstmy = stripslashes("$rstmy"); }
$rstmy = htmlspecialchars($rstmy);
}

if (isset($_POST["freq"])) {
$freq = $_POST["freq"];
$freq = mb_convert_kana($freq, 'a');
if (get_magic_quotes_gpc()) { $freq = stripslashes("$freq"); }
$freq = htmlspecialchars($freq);
$freq = str_replace(",", "&#44;", $freq);
}

if (isset($_POST["mode"])) {
$mode = $_POST["mode"];
$mode = mb_convert_kana($mode, 'a');
if (get_magic_quotes_gpc()) { $mode = stripslashes("$mode"); }
$mode = htmlspecialchars($mode);
}

if (isset($_POST["op"])) {
$op = $_POST["op"];
$op = mb_convert_kana($op, 'a');
if (get_magic_quotes_gpc()) { $op = stripslashes("$op"); }
$op = htmlspecialchars($op);
$op = str_replace(",", "&#44;", $op);
}

if (isset($_POST["qth"])) {
$qth = $_POST["qth"];
$qth = mb_convert_kana($qth, 'a');
if (get_magic_quotes_gpc()) { $qth = stripslashes("$qth"); }
$qth = htmlspecialchars($qth);
$qth = str_replace(",", "&#44;", $qth);
}

if (isset($_POST["qsl"])) {
$qsl = $_POST["qsl"];
$qsl = mb_convert_kana($qsl, 'a');
if (get_magic_quotes_gpc()) { $qsl = stripslashes("$qsl"); }
$qsl = htmlspecialchars($qsl);
$qsl = str_replace(",", "&#44;", $qsl);
}

if (isset($_POST["rem"])) {
$rem = $_POST["rem"];
$rem = mb_convert_kana($rem, 'a');
if (get_magic_quotes_gpc()) { $rem = stripslashes("$rem"); }
$rem = htmlspecialchars($rem);
$rem = str_replace(",", "&#44;", $rem);
}

$data = fopen("./logdata.csv","r");

$bdata = fgets($data);

list($bcallsign,$bdate,$bstart,$bzone,$bcq,$brstur,$brstmy,$bfreq,$bmode,$bop,$bqth,$bqsl,$brem) = explode(",",$bdata);

fclose($data);

if (($bcallsign != $callsign) or ($bstart != $start)){
$time = date("Y/n/j G:i");
$ip = getenv("REMOTE_ADDR");
$host = gethostbyaddr(getenv("REMOTE_ADDR"));
$iphost = ($host . "/" . $ip);
$log = file("./logdata.csv");
$topwrite = "$callsign,$date,$start,$zone,$cq,$rstur,$rstmy,$freq,$mode,$op,$qth,$qsl,$rem,$time,$ip,$host\n";

$write = fopen("./logdata.csv","w");
flock($write, LOCK_EX);
fputs($write, $topwrite);
for($i = 0; $i < 999999; $i++){
fputs($write, $log[$i]);
}
flock ($write, LOCK_UN);
fclose ($write);
}
}
?>

<!DOCTYPE html>

<html lang="ja">

<head>
<meta charset="utf-8">
<meta name="viewport" content="width=device-width, initial-scale=1">
<link rel="shortcut icon" href="https://jg3rtl.info/logicon.ico" type="image/x-icon">
<meta name="author" content="JG3RTL(Hashimoto Mitsuhiro)">
<link rel="stylesheet" href="./logbook-d.css">
<link rel="alternate stylesheet" href="./logbook.css" title="lightmode">
<!-- † -->
<title>WebLogBook</title>
</head>

<body>
<h1>Log Book</h1>

<h2>record</h2>
<table>
<tr>
<th class="cell-date" scope="col">date</th>
<th class="cell-start" scope="col">start</th>
<th class="cell-time" scope="col">time zone</th>
<th class="cell-callsign" scope="col">callsign</th>
<th class="cell-cq" scope="col">call/res</th>
<th class="cell-rst" scope="col">RST(his)</th>
<th class="cell-rst" scope="col">RST(my)</th>
<th class="cell-freq" scope="col">band(MHz)</th>
<th class="cell-mode" scope="col">mode</th>
<th class="cell-op" scope="col">op</th>
<th class="cell-qth" scope="col">QTH</th>
<th class="cell-qsl" scope="col">QSL</th>
<th class="cell-rem" scope="col">remarks</th>
</tr>
</table>

<?php
$log = file("./logdata.csv");
if (!$line) {
$line = 0;
}
$pageline = 10;
for ($i = $line; $i < $line+$pageline; $i++) {
$list = explode(",",$log[$i]);
if(($list[0] != "") or ($list[1] != "")){
?>

<table>
<tr>
<td class="cell-date"><?php print $list[1]; ?></td>
<td class="cell-start"><?php print $list[2]; ?></td>
<td class="cell-time"><?php print $list[3]; ?></td>
<td class="cell-callsign"><?php print $list[0]; ?></td>
<td class="cell-cq"><?php print $list[4]; ?></td>
<td class="cell-rst"><?php print $list[5]; ?></td>
<td class="cell-rst"><?php print $list[6]; ?></td>
<td class="cell-freq"><?php print $list[7]; ?></td>
<td class="cell-mode"><?php print $list[8]; ?></td>
<td class="cell-op l"><?php print $list[9]; ?></td>
<td class="cell-qth l"><?php print $list[10]; ?></td>
<td class="cell-qsl"><?php print $list[11]; ?></td>
<td class="cell-rem l"><?php print $list[12]; ?></td>
</tr>
</table>

<?php
}
}
$totalline = (count($log));
$totalpage = ceil(($totalline / $pageline));
if ($totalline > $pageline) {
$back = $totalline;
$now = 1;
$next = 0;

print "<div class='page'>";
for ($i = $line; $back >= 1; $i++) {
if ($line == $next) {
print "<span class='now'>" . "$now" . "</span>&nbsp;";
}
else {
print "<a href='logbook_r-d.php?line=" . $next . "'><span class='pno'>" . $now . "</span></a> ";
}
$now++;
$next = $next + $pageline;
$back = $back - $pageline;
}
print "</div>";
}
?>

</body>
</html>